namespace math4d
{
	class OPER;
	class vector
	{
	public:
		double v[4];
		vector ();
		vector (double a1, double a2, double a3, double a4);
		vector operator+= (const vector& a);
		vector operator-= (const vector& a);
		vector operator*= (const double& d);
		vector operator*= (const OPER& A);
		void print ();
	};
	
	class OPER
	{
		int i, j;
		unsigned int ax, ay;
	public:
		double matrix[4][4];
		OPER ();
		void LoadTurn(double, unsigned int, unsigned int, int sw = 0);
		void LoadProj(unsigned int, unsigned int);
		void print();
		void operator() (vector& x);
	};
	
	vector operator* (const vector& x, const OPER& A);
	vector operator+ (const vector& a, const vector& b);
	vector operator- (const vector& a, const vector& b);
	vector operator* (const vector& a, const double& d);
	vector operator* (const double& d, const vector& a);
	vector operator/ (const vector& a, const double& d);
}
